/*---------------------------------------------------------------------------
  Project:  ImageDb
  File:     ImageIOUtility.h
  
  [eBeB
  ---------------------------------------------------------------------------*/
#ifndef IMAGE_IO_UTILITY_H_
#define IMAGE_IO_UTILITY_H_


#include <nn/assert.h>
#include <nn/types.h>
#include <imgdb/Core/ImageDbResult.h>


namespace imgdb {
    namespace util {


/*!----------------------------------------------------------------------
  @brief    ǗĂʐ^擾
  @return   ʐ^
  @details
  SDJ[hFłĂȂꍇ̓[Ԃ܂B<BR>

  {֐͎sɈꎞI 35KB ̃܂B
  -----------------------------------------------------------------------*/
int GetRegisteredPictureNum();

/*!--------------------------------------------------------------------------*
  @brief    ʐ^̎cBeς
  @param[out]   pResult     ʁikj
  @return   ʐ^̎cBe
  @details
  c󂫗eʂcBeς܂B<BR>
  Ǘ\Ȏʐ^ƃ[r[̍ő吔 3000 ܂łłBςɂ͂̍ő吔
  l܂B<BR>
  ̌ς薇̓jeh[3DSJƓłB<BR>
  SDJ[hFłĂȂꍇ̓[Ԃ܂B<BR>
  <BR>
  pResultɂ͌όʂi[܂B<BR>
  ς薇Pȏ̏ꍇ ResultSuccess i[܂B<BR>
  ς薇ÔƂA̗RƂĈȉ̌ʂi[܂B<BR>
    EResultErrorOverNumImages<BR>
    EResultErrorFileOperationFailure<BR>
    EResultErrorNotExistStorage<BR>
    EResultErrorWriteProtect<BR>
    EResultErrorInsufficientStorageSpace<BR>
    EResultErrorReadOnlyDbFile<BR>
    EResultErrorNotAvailableStorage<BR>
  {֐ ResultErrorOverNumDcf i[邱Ƃ͂܂B
 *---------------------------------------------------------------------------*/
int EstimateRemainPictureNum(Result* pResult=0);

/*!--------------------------------------------------------------------------*
  @brief    ʐ^̃^Cgj[NIDwIDƓ`FbN
  @param[in]    pPath   ʐ^̃pX
  @param[in]    nUId    ^Cgj[NID
  @return   ꍇtrue
  @details
  pPathJpeg/MpSaverAʐ^IAvbgŎ擾pXw肵܂B<BR>
  ȊÕpXw肵ꍇ̓T|[gOƂȂ܂B<BR>
  ʐ^ǂݍ߂ȂȂǂ̗RŊmFłȂꍇfalseԂ܂B
 *---------------------------------------------------------------------------*/
bool    IsSamePictureTitleUniqueId(const wchar_t* pPath, u32 nUId);

/*!--------------------------------------------------------------------------*
  @brief    ʐ^폜
  @param[in]    pPath   ʐ^̃pX
  @param[in]    nUId    ^Cgj[NID
  @return   
  @details
  pPathJpeg/MpSaverAʐ^IAvbgŎ擾pXw肵܂B<BR>
  ȊÕpXw肵ꍇ̓T|[gOƂȂ܂B<BR>
  nUIdɂ̓Aṽ^Cgj[NIDw肵܂B<BR>
  IDƎʐ^rvĩAvBeʐ^Ɣfjꍇ̂݁A
  ʐ^̍폜s܂B<BR>
  sv̏ꍇResultErrorPermissionDeniedԂ폜Ɏs܂B<BR>

  {֐͎sɈꎞI 138KB ̃܂B
 *---------------------------------------------------------------------------*/
Result  DeletePicture(const wchar_t* pPath, u32 nUId);


/*!----------------------------------------------------------------------
  @brief    ʐ^W߂ImageDbǗ̎ʐ^ɂ
  @return   
  @details
  SDJ[hɂ ImageDb ɊǗĂȂʐ^T ImageDb ɓo^܂B<BR>
  ܂Ao^Ǘt@C֔f܂B<BR>
  PCSDJ[hɒڎʐ^ǉ폜ꂽꍇȂǂɁA̎ʐ^Ǘ
  邽߂ɂ́A{֐ĂяoKv܂B<BR>
  <BR>
  摜̃pXɂẮuImageDb vO~O}jAvmF
  B<BR>
  Aȉ̓_ɂӂB<BR>
  EMP t@Cɕt铯ꖼ JPG t@C͖<BR>
  EMP t@C͕t JPG t@CȂĂ͉\<BR>
  <BR>
  {֐SDJ[h̎ʐ^ɂĂ͏ɎԂꍇ܂B<BR>
  d{^ΉȂǂ̂߂ɏ𒆒fꍇ́A{֐Ăяo
  XbhƂ͕ʂ̃Xbh StopCollect() gpĂB<BR>

  {֐͎sɈꎞI 141KB ̃܂B
  -----------------------------------------------------------------------*/
Result CollectPicture();

/*!----------------------------------------------------------------------
  @brief    ʐ^W߂̏𒆎~
  @details
  ʃXbhACollectPicture() ̏~v܂B<BR>
  {֐PxĂяoł͒~󂯕tȂƂ邽߁A
  CollectPicture()珈ԂĂ܂ŁA~vsKv
  ܂B
  -----------------------------------------------------------------------*/
void StopCollect();


    } // end of namespace util
} // end of namespace imgdb

#endif // IMAGE_IO_UTILITY_H_
